#!/usr/bin/perl

package collector;
use warnings;
use threads;
use threads::shared;
use Class::Struct;

##########################################################
## #
## #
## #
## #
##########################################################


use strict;
#use Switch;
use shared;
use Cwd;
my ($timeStrt,$timeEnd) = (0,0);
my ($errOut) = -1;
my $errOutVm:shared = -1;
my $errOutIO:shared= -1;
my $errOutLparSt:shared= -1;
my $errOuthpmSt:shared= -1;
my $errOutMpst:shared= -1;
my $errOutSvm:shared= -1;
my @iostatStt= "";
my @vmStt = "";
my @SvMonStt = "";
my @hpmStt:shared = "";
my @LparStt:shared = "";
my @Mpstt:shared = "";
my @LparStti = "";
my @IOStt = "";
my $FCAdapter = 0;
my $NoOfLpars = -1;
my @FCAdp = "";
my $TimeEnd = -1; 
my $AMSmode = -1;
my $runInterval = 1;
my @perfCmdArry = ( "vmstat", "svmon","topasrec","mpstat","iostat","fcstat","hpmstat");
my @statperfCmdArry = ( "smtctl", "lsattr", "lssrad", "lparstati", "config","schedo");
my $GblPoolPhymemUsd:shared = 0;
my $GblPoolmemSz:shared = 0;
my $GblPoolLogMemTot:shared = 0;
my $GblPoolLogMemUsd:shared = 0;
my $GblmyMemConsum:shared = 0;
my $GblmyMemConsumHi:shared = 0;
my $GblmyMemConsumLo:shared = 0;
my $lparUtil:shared = 0;
my $lparUtilSys:shared = 0;
my $lparUtilUsr:shared = 0;
my $lparUtilIdl:shared = 0;
my $lparUtilWait:shared = 0;
my $lparUtilPhyCon:shared = 0;
my $pMem:shared = 0;
my $memLoan:shared = 0;
my $hypIn:shared = 0;
my $hypInLt:shared = 0;
my $pgInRt:shared = 0;
my $pgOutRt:shared = 0;
my $lparUtilLo:shared = 0;
my $lparUtilHi:shared = 0;
my $realMem:shared = 0;
my $pinMem:shared =0;
my $pgSpace:shared =0;
my $pgSpUsed:shared = 0;
my $distMemAccess:shared=0;
my $LclMemAccess:shared=0;
my $remtMemAccess:shared = 0;
my $remtMemAccessLo:shared =0;
my $remtMemAccessHi:shared = 0;
my $distMemAccessHi:shared =0;
my $LclMemAccessHi:shared =0;
my $LclMemAccessLo:shared = 0;
my $Gblavailphyproc:shared = 0;
my $GblavailphyprocLo:shared =0;
my $GblavailphyprocHi:shared = 0;
my $APPFnd:shared = 0;
my $distMemAccessLo:shared = 0;
my @VpNum:shared = "";
my %lCpuUtil:shared;
my $TimeStart = -1;
my $hostNm ="";
my $DisgardFirstVal = -1;
my ($lparTYPE,$SmtThrd) = ("","");
my %dskIOStt;
my $smt_flag = -1;
my $TopasrecLpCnt:shared = 0;

sub executeCollector {
    my @temp = "";
    print $shared::RPRTFILE "\n TIMESTART=".localtime();
    my $loop = -1;
    my @runThrds;
    if($shared::execTime > 1800 ){
       $runInterval = int($shared::execTime/1800); # Run every 30mins and collect metrics , average it out.
       $shared::execCount = int($shared::execCount/$runInterval);
    }
    $TimeStart = localtime();
    staticCollector();
    close( $shared::RPRTFILE);
    initializeIosttData();
    for( $loop =1; $loop <= 7 ; $loop++ ){
       my $threadid = threads->new(\&threadFunc, $loop);
       push(@runThrds, $threadid);
    }
    my $tim = localtime();
    foreach (@runThrds) {
       my $thrdRet = $_->join;
    }
    open ( $shared::RPRTFILE, ">>/tmp/$shared::randNo.txt") or die "Cannot open temp file in /tmp. $!";
    $TimeEnd = localtime();
    printMetrics();
    print $shared::RPRTFILE "\n TIMEEND=".localtime();
    print $shared::RPRTFILE "\n ExecTime = $shared::execTime";
}

sub initializeIosttData(){
   my @temp = "";
   my @lslvOut = "";
   @lslvOut = `lspv`;
   foreach (@lslvOut) {
      @temp = split (" ", $_);
      my $hrdDisk = $temp[0];
      share($dskIOStt{$hrdDisk}{'name'});
      share($dskIOStt{$hrdDisk}{'rps'});
      share($dskIOStt{$hrdDisk}{'rpsavgserv'});
      share($dskIOStt{$hrdDisk}{'tps'});
      share($dskIOStt{$hrdDisk}{'wps'});
      share($dskIOStt{$hrdDisk}{'wpsavgserv'});
      share($dskIOStt{$hrdDisk}{'sqfull'});
      share($dskIOStt{$hrdDisk}{'avgsqsz'});
      share($dskIOStt{$hrdDisk}{'latency'});
      share($dskIOStt{$hrdDisk}{'blocked'});
      $dskIOStt{$hrdDisk}{'name'} = $hrdDisk;
      $dskIOStt{$hrdDisk}{'rps'} = 0;
      $dskIOStt{$hrdDisk}{'rpsavgserv'} = 0;
      $dskIOStt{$hrdDisk}{'tps'} = 0;
      $dskIOStt{$hrdDisk}{'wps'} = 0;
      $dskIOStt{$hrdDisk}{'wpsavgserv'} = 0;
      $dskIOStt{$hrdDisk}{'sqfull'} = 0;
      $dskIOStt{$hrdDisk}{'avgsqsz'} = 0;
      $dskIOStt{$hrdDisk}{'latency'} = 0;
      $dskIOStt{$hrdDisk}{'blocked'} = 0;
   }
}
sub staticCollector(){
    print $shared::RPRTFILE "\n TIMESTART=".localtime();
    foreach my $cmd ( @statperfCmdArry ) {
       my @stmlSettings = "";
       my $errOut = -1;
       my @temp = "";
       if ($cmd =~ /smtctl/) {
          ($errOut, @stmlSettings) = runCommand ("smtctl 2>&1");
          if ( $errOut != 0 ) {
             print "\n Command $cmd failed with error @stmlSettings";
          }
          else {
             foreach (@stmlSettings) {
                if ($_ =~ /capable/) {
                   print $shared::RPRTFILE "\nSMTCap=1";
                }
                elsif ($_ =~ /currently enabled/ ){
                   $smt_flag = 1;
                   print $shared::RPRTFILE "=SMTEnbl=1";
                }
                elsif ($_ =~ /system supports / ){
                   @temp = split (" ", $_);
                   print $shared::RPRTFILE "=SMTThrCap=$temp[5]";
                }
                elsif ($_ =~ /^proc/ ) {
                   @temp = split (" ", $_);
                   $SmtThrd = $temp[2];
                   print $shared::RPRTFILE "\nSMTProc=$temp[0]=$temp[2]=";
                   last;
                }
            }
            print $shared::RPRTFILE "TimSt=$timeStrt=TimEnd=$timeEnd";
        }
     }
     if ($cmd =~ /lsattr/) {
        my @phyDisk ="";
        $errOut = -1; 
        ($errOut,@phyDisk) = runCommand ( "lspv 2>&1");
        if ( $errOut == 0) {
           print $shared::RPRTFILE "\nQueue=$#phyDisk=$timeStrt";
           foreach ( @phyDisk ) {
              my @queueStr  = "";
              $errOut = -1;
              my @tempDsk = split (" ",$_);
              ($errOut,@queueStr) = runCommand ("lsattr -El $tempDsk[0]  -a queue_depth  2>&1"); 
              if ( $errOut == 0) {
                 my @tempQ = split (" ",$queueStr[0]);
                 print $shared::RPRTFILE  "=$tempDsk[0]=$tempQ[1]=$tempQ[4]";
              }
              else{
                 print "\n Reading Queue depth of $tempDsk[0] failed with @queueStr";
              }
           }
        } 
        else{
           print "\n Listing physical drive Failed with error @phyDisk";
        }
     }
     if ($cmd =~ /lssrad/) {
        my @Srads= "";
        my $refNo=-1;
        ($errOut,@Srads) =  runCommand ("lssrad -va  2>&1");
        if ( $errOut == 0) {
           foreach ( @Srads ){
              my ($mem, $pc) = (-1,-1);
              chomp;
              if($_ =~ /(\s+\d+\s+)+|^\d+$/ ){
              #if($_ =~ /((^[0-9]*$)|(\s*[0-9]*\s*[0-9]*\.*[0-9]*\s*[0-9]*-[0-9]*$))/ ){
                 @temp = split (" ",$_);
                 if (@temp && $#temp == 0 ) {
                    $refNo = $temp[0];
                 }
                 else {
                    if ( $temp[1] eq "") {
                       $mem = "-1";
                    }
                    else { $mem = $temp[1];}
                    if ( $temp[2] eq "" ) {
                       $pc = "-1";
                    }
                    else { $pc =$temp[2];}
                       print $shared::RPRTFILE  "\nRF=$refNo=SRD=$temp[0]=Mem=$mem=PS=$pc=";
                    }
                 }
              } 
              print $shared::RPRTFILE "TimSt=$timeStrt=TimEnd=$timeEnd";
         }
         else {
           # print "\n lssrad command failed with error @Srads";
         }
      }
      if ($cmd =~ /lparstati/) {
         my $MaxCPUs = "";
         my $ActCPUs = "";
         my $lparOnlneVPs = "";
         my $lparMaxVPs = "";
         my ($lparID,$onlineCPU) = (-1,-1);
         my ($lparMODE,$priorityWt,$lparEntlc,$lparMem) = (-1,-1,-1,-1);
         $lparEntlc = -1;
         my $Interval = 2;
         my ($memWt,$DsrdMem,$memPoolCap) = (-1,-1,-1);
         my ($poolEntl, $poolCap) = (-1,-1);
         $errOut = -1;
         ($errOut,@LparStti) = runCommand ("lparstat -i  2>&1");
         if ( $errOut == 0) {
            foreach ( @LparStti) {
               @temp = split (":",$_);
               chomp(@temp);
               if (/^Node Name/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                     $hostNm = $temp[1]; 
                  }
               }
               elsif (/^Partition Number/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                  $lparID = $temp[1];
                  }
               }
               elsif (/^Type/){
                  if ( $temp[1]!~ /^-$/ && $temp[1] !~ "") {
                  $lparTYPE = $temp[1];
                  }
               }
               elsif (/^Mode/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                  $lparMODE = $temp[1];
                  }
               }
               elsif (/^Variable Capacity Weight/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                  $priorityWt = $temp[1];
                  }
               }
               elsif ($temp[0] =~ /^Entitled Capacity\s+$/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                  $lparEntlc = $temp[1];
                  }
               }
               elsif (/^Online Virtual CPUs/) {
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                  $lparOnlneVPs = $temp[1];
                  }
               }      
               elsif (/^Maximum Virtual CPUs/) {
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                  $lparMaxVPs = $temp[1];
                  }
               }      
               elsif (/^Memory Mode/) {
                  $AMSmode = ($_ =~ /Shared/) ? 1: 0;
               }      
               elsif (/^Desired Memory/) {
                  my @Tmp = split(" ",  $temp[1]);
                  if ( $Tmp[0]!~ /-/ && $Tmp[0] !~ "") {
                  $DsrdMem = $Tmp[0];
                  }
               }      
               elsif (/^Variable Memory Capacity Weight/) {
                  if ( $temp[1] !~ /-/ ){
                     $memWt = $temp[1];
                  } 
               } 
               elsif (/^Entitled Capacity of Pool/){
                  if ( $temp[1] !~ /-/ ){
                     $poolEntl = $poolEntl + $temp[1];
                  } 
               }
               elsif (/^Online Memory/){
                  $lparMem = $temp[1];
               }
               elsif (/^Physical Memory in the Pool/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                     $memPoolCap = $temp[1];
                  }
               }
               elsif (/^Maximum Capacity of Pool/){
                  if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                     $poolCap = $poolCap + $temp[1];
                  } 
               }
           }
        }
        else {
           print "\n lparstat -i command failed with error @LparStti";
           return;
        }
        $poolEntl = $poolEntl  /100;
        $poolEntl = sprintf ("%#.3f",$poolEntl);
        $poolCap = $poolCap /100;
        $poolCap = sprintf ("%#.3f",$poolCap);
        my $Ratio = ( $lparTYPE =~ /Shared/) ? $lparOnlneVPs/$lparEntlc:0;
        $Ratio = sprintf ("%#.3f",$Ratio );
        print $shared::RPRTFILE  "\nHostNm=$hostNm";
        print $shared::RPRTFILE  "\nLparID=$lparID";
        print $shared::RPRTFILE  "\nlparTYPE=$lparTYPE";
        print $shared::RPRTFILE  "\nlparMode=$lparMODE";
        print $shared::RPRTFILE  "\nlparMem=$lparMem";
        print $shared::RPRTFILE  "\nlparOnlineVP=$lparOnlneVPs";
        print $shared::RPRTFILE  "\nMaxVP=$lparMaxVPs";
        print $shared::RPRTFILE  "\nAMS=$AMSmode=memWt=$memWt=dsrdMem=$DsrdMem=memPoolcap=$memPoolCap";
        print $shared::RPRTFILE  "\nPriorityWt=$priorityWt";
        print $shared::RPRTFILE  "\nlparEntl=$lparEntlc";
        print $shared::RPRTFILE  "\npoolEntl=$poolEntl";
        print $shared::RPRTFILE  "\npoolCap=$poolCap";
        
        print $shared::RPRTFILE  "\nratio=$Ratio";
        if (defined $shared::FileName){
           $hostNm = substr($hostNm,1);
           print $shared::RPRTFILE  "\nFileName=powerVM_advisor_".$hostNm."_".time().".xml";
        } 
    }
    if ($cmd =~ /config/) {
       my (@hmcTemp,@Temp) = ("","");
       my ($onlineSysCPU) = -1;
       my ($sysMem,$sysAdap,$sysFw,$sysPoolSize, $syssharedpools) = (-1,-1,-1,-1,-1);
       my ($sysFreq,$sysFamily,$sysModel,$FirmwareLevel) = ("","","","");
       my @ConfigStr = "";
       $errOut = -1; 
       ($errOut,@ConfigStr) = runCommand ("prtconf 2>&1");
       if ( $errOut == 0) {
          foreach ( @ConfigStr) {
             @temp = split (":",$_);
             chomp(@temp);
             if (/^System Model/) {
                if ( $temp[1]!~ /^-$/ && $temp[1] !~ "") {
                $sysModel = $temp[1];
                }
             }
             elsif(/^Processor Type/) {
                if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                $sysFamily = $temp[1]; 
                } 
             }
             elsif(/^Platform Firmware level/) {
                if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                $sysFw = $temp[1]; 
                }
             }
             elsif(/^Processor Clock Speed/) {
                if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                $sysFreq = $temp[1]; 
                }
             }
             elsif(/^Platform Firmware level/) {
                if ( $temp[1]!~ /-/ && $temp[1] !~ "") {
                $FirmwareLevel = $temp[1]; 
                }
             }
             elsif(/^fcs/) {
                @Temp = split("\\s+",$temp[0]);
                $FCAdp[$FCAdapter] = $temp[0];
                $FCAdapter++;
             }
          }
       }
       else{
          print "\n prtconf command failed with error @ConfigStr";
       }
       my ($hmcErr,$hmcCmd) = (-1,"");
       my $console = (defined $shared::sdmc)? "SDMC":"HMC";  
       ($hmcErr,$hmcCmd) = runHMCCommand ("lssyscfg -r sys -m $shared::cec"); # to find turbo core capability
       if ( $hmcErr == 0) {
          print $shared::RPRTFILE  "\nSysCfg=";
          @hmcTemp = split ("\,",$hmcCmd);
          my ($Turbo,$AMS,$AME,$LPM)=(0,0,0,0);
          foreach ( @hmcTemp ) {
             @temp = split ("=");
             if ( /curr_turbocore/ ){
                if ( $temp[1] == "0" ){
                   $Turbo = 0;
                }
                elsif ( $temp[1] == "1") {
                   $Turbo = 1;
                }
            }
            if ( /active_mem_expansion_capable/ ){
               if ( $temp[1] == "0" ){
                  $AME = 0;
               }
               elsif ( $temp[1] == "1") {
                  $AME = 1;
               }
            }
            if ( /active_mem_sharing_capable/ ){
               if ( $temp[1] == "0" ){
                  $AMS = 0;
               }
               elsif ( $temp[1] == "1") {
                  $AMS = 1;
               }
            }
            if ( /active_lpar_mobility_capable/ ){
               if ( $temp[1] == "0" ){
                  $LPM = 0;
               }
               elsif ( $temp[1] == "1") {
                  $LPM = 1;
               }
            }
         }                     
         if ( $Turbo == "0" ){
            print $shared::RPRTFILE  "TurboCore=0=";
         }
         else {
            print $shared::RPRTFILE  "TurboCore=1=";
         }
         if ( $AME == 0 ){
            print $shared::RPRTFILE  "AME=0=";
         }
         else {
            print $shared::RPRTFILE  "AME=1=";
         }
         if ( $AMS == 0 ){
            print $shared::RPRTFILE  "AMS=0=";
         }
         else {
            print $shared::RPRTFILE  "AMS=1=";
         }
         if ( $LPM == "0" ){
            print $shared::RPRTFILE  "ActiveLPM=0=";
         }
         else {
            print $shared::RPRTFILE  "ActiveLPM=1=";
         }
      }
      else{
         print "\n $console command failed : $hmcCmd";
      }
      ($hmcErr,$hmcCmd) = (-1,""); 
      ($hmcErr,$hmcCmd) = runHMCCommand ("lshwres -r io --rsubtype slot -m $shared::cec | grep -v Empty"); # to find IO adapters 
      if ( $hmcErr == 0) {
         my %phyAdap ;
         @hmcTemp = split ("\,",$hmcCmd);
         foreach ( @hmcTemp ) {
            @temp = split ("=");
            if ( /description/ ){
               if (exists ($phyAdap{$temp[1]})) {
                  $phyAdap{$temp[1]}++;
               }
               else{
                  $phyAdap{$temp[1]} =1;
               }    
            }
         }
         print $shared::RPRTFILE  "\nAdapters=";
         foreach (keys %phyAdap) {
           if (defined $phyAdap{$_}){  
               print $shared::RPRTFILE  "$_-$phyAdap{$_} nos :";
           }        
         }
      }
      else {
         print "\n $console command failed : $hmcCmd";

      } 
      ($hmcErr,$hmcCmd) = (-1,""); 
      ($hmcErr,$hmcCmd) = runHMCCommand ("lshwres -r mem --level sys -m $shared::cec"); # to find mem present
      if ($hmcErr == 0){
         @hmcTemp = split ("\,",$hmcCmd);
         foreach ( @hmcTemp ) {
            @temp = split ("=");
            if ( /configurable_sys_mem/ ){
               $sysMem = $temp[1];
            }
            if ( /installed_sys_mem/ ){
               print $shared::RPRTFILE  "\nServerMem=$sysMem=ServerMaxMem=$temp[1]";
            }
         }
      }
      else {
         print "\n $console command failed : $hmcCmd";
      }
      ($hmcErr,$hmcCmd) = (-1,""); 
      ($hmcErr,$hmcCmd) = runHMCCommand ("lshwres -r proc --level sys -m $shared::cec"); # to find proc present
      if ($hmcErr == 0){
         @hmcTemp = split ("\,",$hmcCmd);
         foreach ( @hmcTemp ) {
            @temp = split ("=");
            if ( /configurable_sys_proc_units/ ){
               $onlineSysCPU = $temp[1];
            }
            if ( /installed_sys_proc_units/ ){
               print $shared::RPRTFILE  "\nServerProc=$onlineSysCPU=ServerMaxProc=$temp[1]";
            }
            if ( /max_procs_per_lpar/ ){
                print $shared::RPRTFILE  "\nSPPL=$temp[1]";
            }
         }
      }
      else {
         print "\n $console command failed : $hmcCmd";
      }
      if($shared::hmcUsr ne "padmin"){
      ($hmcErr,$hmcCmd) = (-1,""); 
      ($hmcErr,$hmcCmd) = runHMCCommand ("lshwres -r procpool -m $shared::cec"); # to find procpool present
      if ($hmcErr == 0){
         @hmcTemp = split ("\n",$hmcCmd);
         my @Temp1;
         my $poolCnt = $#hmcTemp + 1;
         print $shared::RPRTFILE  "\nServerProcpool=";
         print $shared::RPRTFILE  "$poolCnt=";
         foreach ( @hmcTemp ) {
            @temp = split("\,");
            foreach(@temp){
               @Temp1 = split("=");
               if ( $Temp1[0] =~ /^name$/ ){
                  print $shared::RPRTFILE  "$Temp1[1]=";
                  $poolCnt++;
                  if ($Temp1[1] =~ /DefaultPool/) {
                     print $shared::RPRTFILE  "\"\"=";
                  }
               }
               elsif ( $Temp1[0] =~ /max_pool_proc_units/ ){
                  print $shared::RPRTFILE  "$Temp1[1]=";
               }
            }
         }
      }
      else {
	    print "\n $console command failed : $hmcCmd";
         }
      }
      print $shared::RPRTFILE  "\nFamily=$sysFamily";
      print $shared::RPRTFILE  "\nModel=$sysModel";
      print $shared::RPRTFILE  "\nFirmware=$sysFw";
      print $shared::RPRTFILE  "\nFreq=$sysFreq";
      $errOut = -1;
      ($errOut,@ConfigStr) = runCommand ("oslevel 2>&1");
      if ( $errOut == 0) {
         chomp(@ConfigStr);
         print $shared::RPRTFILE  "\nOSLevel=@ConfigStr";
      }
      else {
         print "\n oslevel command failed with error @ConfigStr";
      }
      $errOut = -1;
      ($errOut,@ConfigStr) = runCommand ("what /unix | grep build 2>&1");
      if ( $errOut == 0) {
         foreach ( @ConfigStr) {
            @temp = split (" ",$_);
            print $shared::RPRTFILE  "\nbuildInfo=$temp[2] $temp[3] $temp[4] $temp[6]";
         }
      }
      else {
         print "\n oslevel command failed with error @ConfigStr";
      }
   }
   if ($cmd =~ /schedo/) {
      my @schedoArry ="";
      my ($vpmPolicy,$vpmThresh) = (-1,-1);
      $errOut = -1;
      ($errOut,@schedoArry) = runCommand ("schedo  -F -L 2>&1");
      if ( $errOut == 0) {
         foreach ( @schedoArry ){
            if (/^vpm_fold_threshold/) {
               @temp = split (" ",$_);
               $vpmThresh = $temp[1];
            }
            elsif (/^vpm_fold_policy/) {
               @temp = split (" ",$_);
               $vpmPolicy = $temp[1];
            }
         }
         if ( $vpmPolicy != 0 && $vpmPolicy <= 3 ){
            print $shared::RPRTFILE  "\nVPMEnbl=1=FoldThresh=$vpmThresh=";
         }
         else {
           print $shared::RPRTFILE  "\nVPMEnbl=0=FoldThresh=$vpmThresh=";
         }
         print $shared::RPRTFILE "TimSt=$timeStrt=TimEnd=$timeEnd";
      }
      else {
        print "\n schedo -F -L command failed with error @schedoArry";
        print "\n Note: schedo -F -L not supported on AIX 5 level"; 
      }
    }
 }
}
sub consumeSvmon () {
   my @temp = "";
   if ( $errOutSvm == 0) {
      foreach ( @SvMonStt) {
         @temp = split (" ",$_);
         if (/^memory/ ) {
            $realMem= ($temp[1] * 4096)/1048576;
            $pinMem= (($temp[4] * 4096)/1048576) + $pinMem ;  
         }
         elsif (/^pg space/ ) {
            $pgSpace= ($temp[2] * 4096)/1048576;
            $pgSpUsed= (($temp[3] * 4096)/1048576) + $pgSpUsed;
         }
      }
   }
   else{
     print "\n svmon Failed with $errOutSvm ";
     exit;
   }
}

sub consumeHpmstat () {
   my @temp = "";
   if ( $errOuthpmSt == 0) {
      foreach ( @hpmStt) {
         if (/PM_DATA_FROM_RMEM/) {
            @temp = split (" ",$_);
            $remtMemAccess = $remtMemAccess + $temp[7];
               if ( $temp[7] < $remtMemAccessLo ){
                  $remtMemAccessLo = $temp[7];
               }
               if ( $temp[7] > $remtMemAccessHi ){
                  $remtMemAccessHi = $temp[7];
               }
           }
           elsif (/PM_DATA_FROM_DMEM/){
              @temp = split (" ",$_);
              $distMemAccess = $distMemAccess + $temp[7];
              if ( $temp[7] < $distMemAccessLo ){
                 $distMemAccessLo = $temp[7];
              }
              if ( $temp[7] > $distMemAccessHi ){
                 $distMemAccessHi = $temp[7];
              }
          }
          elsif (/PM_DATA_FROM_LMEM/){
            @temp = split (" ",$_);
            $LclMemAccess = $LclMemAccess + $temp[7];
            if ( $temp[7] < $LclMemAccessLo){
               $LclMemAccessLo = $temp[7];
            }
            if ( $temp[7] > $LclMemAccessHi ) {
               $LclMemAccessHi  = $temp[7];
            }
         }                   
      }
   }
}

sub consumeMpsstat () {
    my $nextExp = "";
    my @lCpus = "";
    my @temp;
    my $DisgardFirstVal = -1;
    if ( $errOutMpst == 0) {
       foreach (@Mpstt) {
          my $ttemp = $_;
          if ($DisgardFirstVal == -1 ){
             $DisgardFirstVal = 0;
             next;
          }
          $ttemp =~ s/^\s+//;
          $ttemp =~ s/\s+$//;
          if ( $ttemp =~ /Proc/) {
             $nextExp = "procval";
             @temp = split ("\\s+",$ttemp);
             foreach (@temp) {
                my @tempProc = split ("c");
                my $FndItem = -1;  
                foreach (@VpNum) {
                   if ( /$tempProc[1]/){
                      $FndItem = 0;
                   }
                }    
                push (@VpNum, $tempProc[1]) if ($FndItem == -1);
              }
           }
           elsif ( $ttemp =~ /^cpu/ ) {
              @lCpus = split ("\\s+",$ttemp);
              foreach (@lCpus) {
                 if ($_ !~ /^\s*$/){ 
                    if (!defined $lCpuUtil{$_}) {
                       $lCpuUtil{$_} = 0;
                    }
                 }
              }
              $nextExp = "cpuval";
           }
           elsif ($ttemp =~ /----/) {
             $nextExp = "";
           }
           elsif ($ttemp =~ /^\d+\.\d+/ ) {
              if ( $nextExp eq "cpuval" ){
                 @temp = split ("%\\s*",$ttemp);
                 my $Cnt = 1;
                 foreach (@temp) {  
                   if ($_ !~ /^\s*$/){ 
                      if (defined $lCpus[$Cnt]) { 
                         $lCpuUtil{$lCpus[$Cnt]} = $lCpuUtil{$lCpus[$Cnt]} + $_;
                         $Cnt++;
                      }
                    }
                 }
              }    
           }
        } 
     }
	 else {
        print "\n mpstat command failed with error @Mpstt";
     }
}
sub consumeIostat () {
   my $numFtch=0;
   my $hrdDisk = "";
   my @temp;
   if ( -e "/tmp/iostat.out" && -r "/tmp/iostat.out") {
      my $IOFILE; 
      open IOFILE, "/tmp/iostat.out" or die $!;
      foreach (<IOFILE>) {
         @temp = split (" ", $_);
         if (/hdisk|read|write|queue/) {
            if ( /hdisk/){
               $hrdDisk = $temp[0];
               $numFtch = 1 ;
            }
            elsif ( /read/ ){
               $numFtch=2;
            }
            elsif ( /write/ ){
               $numFtch=3;
            }
            elsif ( /queue/ ){
               $numFtch=4;
            }
         }
         elsif ( $numFtch == 1) {
            $dskIOStt{$hrdDisk}{'tps'} =  $temp[2];
         }
         elsif ( $numFtch == 2) {
            $dskIOStt{$hrdDisk}{'rps'} = $temp[0];
            if ( $temp[1] =~ /[Ss]$/ ){
               $temp[1] =~ s/S//g;
               $temp[1] = $temp[1] * 1000;
            }
            elsif ($temp[1] =~ /[Hh]$/ ){
               $temp[1] =~ s/H//g;
               $temp[1] = $temp[1] * 1000 * 60 *60;
            }
            $dskIOStt{$hrdDisk}{'rpsavgserv'} = $temp[1];
         }
         elsif ( $numFtch == 3) {
            $dskIOStt{$hrdDisk}{'wps'} = $temp[0];
            if ( $temp[1] =~ /[Ss]$/ ){
               $temp[1] =~ s/S//g;
               $temp[1] = $temp[1] * 1000;
            }
            elsif ($temp[1] =~ /[Hh]$/ ){
               $temp[1] =~ s/H//g;
               $temp[1] = $temp[1] * 1000 * 60 *60;
            }
            $dskIOStt{$hrdDisk}{'wpsavgserv'} = $temp[1];
         }
         elsif ( $numFtch == 4) {
            my $TmpStore=0;
            my $TmpStorew=0;
            $numFtch = 5;
            $dskIOStt{$hrdDisk}{'sqfull'} = $temp[5];
            $dskIOStt{$hrdDisk}{'avgsqsz'} = $temp[4]; 
            if ( $dskIOStt{$hrdDisk}{'tps'} != 0 &&
               $dskIOStt{$hrdDisk}{'avgsqsz'} != 0 ) { 
               $TmpStore = $dskIOStt{$hrdDisk}{'rps'} * $dskIOStt{$hrdDisk}{'rpsavgserv'};
               $TmpStorew = $dskIOStt{$hrdDisk}{'wps'} * $dskIOStt{$hrdDisk}{'wpsavgserv'};
               $dskIOStt{$hrdDisk}{'latency'} = $dskIOStt{$hrdDisk}{'latency'} + ((( $TmpStore + $TmpStorew)/$dskIOStt{$hrdDisk}{'tps'})/$dskIOStt{$hrdDisk}{'avgsqsz'});
            }
            if ($dskIOStt{$hrdDisk}{'sqfull'} != 0 && $dskIOStt{$hrdDisk}{'tps'} != 0) {
               $dskIOStt{$hrdDisk}{'blocked'} = $dskIOStt{$hrdDisk}{'blocked'} + ($dskIOStt{$hrdDisk}{'sqfull'}/$dskIOStt{$hrdDisk}{'tps'});
            }
         }
      } 
      close(IOFILE);
   }
}
sub consumeVmstat () {
   my $utilTmp; 
   my $DisgardFirstVal = -1;
   my @temp; 
   foreach ( @vmStt) {
      if ( $DisgardFirstVal == -1 ){
         $DisgardFirstVal = 0;
         next;
      }
      if (/^\s\d+/ ) {
         @temp = split (" ",$_);
         if ( $lparTYPE =~ /Shared*/ ) { 
            $utilTmp = $temp[18];
         }
         else {
            $utilTmp = $temp[13] + $temp[14];
         }
         $pgInRt= $pgInRt+ $temp[5];
         $pgOutRt= $pgOutRt+ $temp[6];
         if ( $lparUtilLo== -1 ) {
            $lparUtilLo= $utilTmp;
            $lparUtilHi= $utilTmp;
         }
         $lparUtil= $lparUtil+ $utilTmp;
         $lparUtilSys = $lparUtilSys + $temp[14];
         $lparUtilUsr = $lparUtilUsr + $temp[13];
         $lparUtilIdl = $lparUtilIdl + $temp[15];
         $lparUtilWait = $lparUtilWait + $temp[16];  
         $lparUtilPhyCon = $lparUtilPhyCon + $temp[17];
         if ( $lparUtilLo> $utilTmp ){
            $lparUtilLo= $utilTmp;
         }
         if ( $lparUtilHi< $utilTmp ){
            $lparUtilHi= $utilTmp;
         }
         if ( $AMSmode == 1){
            $pMem= $pMem+ $temp[21];
            $memLoan= $memLoan+ $temp[22];
            $hypIn= $hypIn+ $temp[19];
            $hypInLt = $hypInLt + $temp[20];
         }
      }
   }
}
sub printMetrics (){
    my @temp = "";
    my $loop;
    if ( defined $shared::sysLevel && $shared::sysLevel =~ /sys/ ){
       print $shared::RPRTFILE  "\nAdvLevel=SYSTEM";
    }
    else {
       print $shared::RPRTFILE  "\nAdvLevel=LPAR";
    }
    foreach my $cmd ( @perfCmdArry ) {
       if ($cmd =~ /mpstat/) {
          my $lCpuCnt = 0;
          $lCpuCnt = keys  %lCpuUtil;  
          print $shared::RPRTFILE  "\nMpstat=$lCpuCnt";
          my $Cnt = 0;
          my $Virproc = 0;
          foreach (keys %lCpuUtil ){
             if ($_ !~ /^\s*$/){
                if ( $Cnt == 0 && defined $VpNum[$Virproc]) {
                   print $shared::RPRTFILE "\nVp=$VpNum[$Virproc]";
                }
                $lCpuUtil{$_} = sprintf("%3.2f",$lCpuUtil{$_}/(($shared::execCount * $runInterval) - 1)); 
                print $shared::RPRTFILE  "=$lCpuUtil{$_}"; 
                $Cnt++;   
             }
             if ( $Cnt == $SmtThrd ){
                $Cnt = 0 ;
                $Virproc++;
             }
          } 
       }
       if ($cmd =~ /vmstat/) {
          if ( $errOutVm == 0) {
             my $PageRate = ((($pgInRt*4096)/($shared::execCount * $runInterval)) + (($pgOutRt*4096)/($shared::execCount * $runInterval)))/2;
             $lparUtil=sprintf("%#.2f",($lparUtil/($shared::execCount * $runInterval)));
             $lparUtilSys=sprintf("%#.2f",($lparUtilSys/($shared::execCount * $runInterval)));
             $lparUtilUsr=sprintf("%#.2f",($lparUtilUsr/($shared::execCount * $runInterval)));
             $lparUtilIdl=sprintf("%#.2f",($lparUtilIdl/($shared::execCount * $runInterval)));
             $lparUtilWait=sprintf("%#.2f",($lparUtilWait/($shared::execCount * $runInterval)));
             $lparUtilPhyCon=sprintf("%#.2f",($lparUtilPhyCon/($shared::execCount * $runInterval)));
             print $shared::RPRTFILE  "\nlparUtil=$lparUtil=lparUtilLo=$lparUtilLo=lparUtilHi=$lparUtilHi=lparUtilUser=$lparUtilUsr=lparUtilSys=$lparUtilSys=lparUtilIdle=$lparUtilIdl=lparUtilWait=$lparUtilWait=lparUtilPhyCon=$lparUtilPhyCon";
             print $shared::RPRTFILE "=TimSt=$TimeStart=TimEnd=$TimeEnd";
             print $shared::RPRTFILE "\nPageRate=$PageRate";
             $pMem=sprintf("%#.2f",($pMem/($shared::execCount * $runInterval)));
             $memLoan=sprintf("%#.2f",($memLoan/($shared::execCount * $runInterval)));
             $hypIn=sprintf("%#.2f",($hypIn/($shared::execCount * $runInterval))); 
             $hypInLt=sprintf("%#.2f",($hypInLt/($shared::execCount * $runInterval))); 
             print $shared::RPRTFILE "=pMem=$pMem=LoanPg=$memLoan=PhypIn=$hypIn=hypInLat=$hypInLt";
             print $shared::RPRTFILE "=TimSt=$TimeStart=TimEnd=$TimeEnd";
          }
          else{
             print "\n vmstat command failed";
             print "\n Note: vmstat -h is not supported on AIX 5";
          }
       }
       if ($cmd =~ /svmon/) {
          $pgSpace = sprintf("%#.2f",$pgSpace); 
          $pgSpUsed = sprintf("%#.2f",($pgSpUsed/($shared::execCount * $runInterval)));
          $pinMem = sprintf("%#.2f",($pinMem / ($shared::execCount * $runInterval)));
          print $shared::RPRTFILE "\nPin=$pinMem=PgSp=$pgSpace=PgSpU=$pgSpUsed=Real=$realMem";
          print $shared::RPRTFILE "=TimSt=$TimeStart=TimEnd=$TimeEnd";
       }
       if ($cmd =~ /hpmstat/) {
          $distMemAccess = $distMemAccess/($shared::execCount * $runInterval);
          $remtMemAccess = $remtMemAccess/($shared::execCount * $runInterval);
          $LclMemAccess = $LclMemAccess/($shared::execCount * $runInterval);
          $distMemAccess = sprintf("%#.2f",$distMemAccess);
          $remtMemAccess = sprintf("%#.2f",$remtMemAccess);
          $LclMemAccess = sprintf("%#.2f",$LclMemAccess);
          print $shared::RPRTFILE  "\nDistMemAcc=$distMemAccess=distMemAccessLo=$distMemAccessLo=distMemAccessHi=$distMemAccessHi";
          print $shared::RPRTFILE  "\nRemtMemcc=$remtMemAccess=remtMemAccessLo=$remtMemAccessLo=remtMemAccessHi=$remtMemAccessHi";
          print $shared::RPRTFILE  "\=LocalMemAcc=$LclMemAccess=LocalMemAccessLo=$LclMemAccessLo=LocalMemAccessHi=$LclMemAccessHi";
          print $shared::RPRTFILE "=TimSt=$TimeStart=TimEnd=$TimeEnd";
       }
       if ($cmd =~ /iostat/) {
          foreach( keys %dskIOStt) {
             my $IOTemp ;
             my $DiskFull ;
             $IOTemp = $dskIOStt{$_}{'latency'}/($shared::execCount * $runInterval);
             $IOTemp = sprintf ("%3.2f",$IOTemp );
             print $shared::RPRTFILE "\nIOdsk=$_=IOLat=$IOTemp";
             $IOTemp = $dskIOStt{$_}{'blocked'}/($shared::execCount * $runInterval);
             $IOTemp = sprintf ("%3.2f",$IOTemp );
             print $shared::RPRTFILE "=IOBlck=$IOTemp=";
             $DiskFull = ( $IOTemp > 0.8 )? 1 : 0;
             print $shared::RPRTFILE "DskFull= $DiskFull=";
             print $shared::RPRTFILE "QFULL= $dskIOStt{$_}{'sqfull'}=";
             print $shared::RPRTFILE "TimSt=$TimeStart=TimEnd=$TimeEnd";
          } 
       }
       if ($cmd =~ /topasrec/) {  # This should be executed always after lparstat -i cmd, maxCPU is derived
          $Gblavailphyproc = $Gblavailphyproc/$TopasrecLpCnt;
          $Gblavailphyproc = sprintf ("%#.2f", $Gblavailphyproc);
          if ( $APPFnd == 1 ){
             print $shared::RPRTFILE  "\nAvailPoolCap=$Gblavailphyproc=availphyprocLo=$GblavailphyprocLo=availphyprocHi=$GblavailphyprocHi=";
          }
          else {
             print $shared::RPRTFILE  "\nAvailPoolCap=-1=availphyprocLo=-1=availphyprocHi=-1=";
          }
          $GblPoolPhymemUsd = $GblPoolPhymemUsd/$TopasrecLpCnt;
          $GblPoolmemSz = $GblPoolmemSz/$TopasrecLpCnt;
          $GblPoolLogMemTot = $GblPoolLogMemTot/$TopasrecLpCnt;
          $GblPoolLogMemUsd = $GblPoolLogMemUsd/$TopasrecLpCnt;
          $GblmyMemConsum = $GblmyMemConsum/$TopasrecLpCnt;
          $GblPoolPhymemUsd = sprintf ("%#.2f", $GblPoolPhymemUsd);
          $GblPoolmemSz = sprintf ("%#.2f",$GblPoolmemSz);
          $GblPoolLogMemTot = sprintf ("%#.2f",$GblPoolLogMemTot);
          $GblPoolLogMemUsd = sprintf ("%#.2f",$GblPoolLogMemUsd);
          $GblmyMemConsum = sprintf ("%#.2f",$GblmyMemConsum);  
          print $shared::RPRTFILE  "\nPoolPhyMemUsed=$GblPoolPhymemUsd=PoolSize=$GblPoolmemSz=TotLogMem=$GblPoolLogMemTot=ActualLogMemUsed=$GblPoolLogMemUsd=CurLprMemUsed=$GblmyMemConsum=CurLprMemUsedHi=$GblmyMemConsumHi=CurLprMemUsedLo=$GblmyMemConsumLo=";
          print $shared::RPRTFILE "TimSt=$TimeStart=TimEnd=$TimeEnd";
       }
   } 
   print $shared::RPRTFILE "\n TIMEEND=".localtime();
   print $shared::RPRTFILE "\n ExecTime = $shared::execTime";
}

sub consumeTopasrec(){
   my $outFile = '/tmp/topasout*';
   my @topasRecOut ;
   my $NextRd = 0;
   my @temp; 
   if ( $errOutLparSt == 0 ){
      my $topasRun = `topasrec -l`;
      while ( $topasRun =~  /\/tmp\/topasout/) {
        `sleep 30`;
        $topasRun = `topasrec -l`; 
      }    
      my $sharedPoolCnt = 0;
      @topasRecOut = `topasout -R summary /tmp/topasout*`; 
      if($? == 0 && grep (/\bAPP\b/, @topasRecOut)){
         my $availphyproc = 0;
         my ($availphyprocLo,$availphyprocHi) = (-1,-1);
         foreach ( @topasRecOut) {
            if ($_ =~ /^Partition Mon/){
               @temp = split (" ", $_);
               $NoOfLpars = $temp[1];
            } 
            if ($_  =~ /APP/){
              $NextRd = 1;
            }
            elsif ($NextRd  == 1 ) {  
              @temp = split (" ",$_);
              chomp(@temp);
              $APPFnd = 1;
              if ( $availphyprocLo == -1 ) {
                $availphyprocLo = $temp[10];
                $availphyprocHi = $temp[10];
                $GblavailphyprocLo = $availphyprocLo;
              }
              $sharedPoolCnt++;
              $availphyproc = $temp[10] + $availphyproc;
              if($availphyprocLo > $temp[10]) {
                 $availphyprocLo = $temp[10];
              }
              if($availphyprocHi < $temp[10]) {
                 $availphyprocHi = $temp[10];
              }
           }
        }
        $availphyproc = $availphyproc/$sharedPoolCnt;
        $Gblavailphyproc = $Gblavailphyproc + $availphyproc; 
        if ( $GblavailphyprocLo > $availphyprocLo ) {
           $GblavailphyprocLo = $availphyprocLo;
        } 
        if ($GblavailphyprocHi <  $availphyprocHi ){   
           $GblavailphyprocHi = $availphyprocHi;
        } 
      }
      else {
      }
      my $lparCnt = 0;
      my $myMemCnt = 0;
      my $poolMemCnt = 0;
      if ( $AMSmode == 1 ){   ## WORK AROUND TO ELIMINATE MEMORY EXITING ERROR. CHeck mempool only if it a AMS lpar.
         my ($PoolPhymemUsd,$PoolmemSz) = (-1,-1);
         my ($PoolLogMemTot,$PoolLogMemUsd,$myMemConsum) = (-1,-1,-1);
         my ($myMemConsumHi,$myMemConsumLo) = (-1,-1);
         @topasRecOut = `topasout -R mempool /tmp/topas*`;
         $NextRd = 0;
         foreach ( @topasRecOut) {
            if ($_  =~ /^Host/){
               $NextRd = 2;
            }         
            elsif ($_ =~ /^mpid/){
               $NextRd = 1;  
            }
            elsif ($_ =~ /---/){
               next;
            }
            elsif ($NextRd == 1){
               @temp = split ("\\s+",$_);
               $PoolPhymemUsd = $PoolPhymemUsd + $temp[2];   
               $PoolmemSz = $PoolmemSz + $temp[1];   
               $PoolLogMemTot = $PoolLogMemTot + $temp[3];
               $PoolLogMemUsd = $PoolLogMemUsd + $temp[4];
               $poolMemCnt++;
               $NextRd = 0;
            }
            elsif ($NextRd == 2 ){
               @temp = split ("\\s+",$_);
               $hostNm =~ s/\s+//g; 
               if ($temp[0] =~ /$hostNm/){
                  $myMemCnt++;
                  $myMemConsum = $myMemConsum + $temp[3]; 
   
                  if($myMemConsumLo == -1 ){
                     $myMemConsumLo = $temp[3]; 
                     $myMemConsumHi = $temp[3]; 
                  }
                  if($myMemConsumLo > $temp[3]){
                     $myMemConsumLo = $temp[3]; 
                  }
                  if($myMemConsumHi < $temp[3]){
                     $myMemConsumHi = $temp[3]; 
                  }
               } 
               $NextRd = 0;
            }       
         }
         $myMemConsum = $myMemConsum / $myMemCnt;
         $PoolPhymemUsd = $PoolPhymemUsd / $poolMemCnt; 
         $PoolmemSz = $PoolmemSz/$poolMemCnt;
         $PoolLogMemTot = $PoolLogMemTot / $poolMemCnt;
         $PoolLogMemUsd = $PoolLogMemUsd / $poolMemCnt;
         $GblmyMemConsum = $GblmyMemConsum + $myMemConsum;
         $GblPoolPhymemUsd = $GblPoolPhymemUsd + $PoolPhymemUsd;
         $GblPoolmemSz = $GblPoolmemSz + $PoolmemSz;
         $GblPoolLogMemTot = $GblPoolLogMemTot + $PoolLogMemTot;
         $GblPoolLogMemUsd = $GblPoolLogMemUsd + $PoolLogMemUsd;
      }
   }
   else{
      print "\n topasrec Failed. No output File.";
   }  
}

sub runHMCCommand () {
    my @cmdLine = (defined $shared::sdmc) ? "smcli "."@_":@_;
    #print "\n Argument - @cmdLine";
    if ( defined $shared::sdmc) {
       $shared::hmc = $shared::sdmc;
       if (!defined $shared::hmcUsr ){
          $shared::hmcUsr = "hscpe";
       }
    }
    $timeStrt = localtime();
    my $retVal = `ssh $shared::hmc -l $shared::hmcUsr '@cmdLine '`;
    $timeEnd = localtime();
    my $errVal = $?;
    if ( $errVal != 0 ){
       (defined $shared::sdmc) ? print "SDMC command Failed: @cmdLine  \n Err - $errVal $retVal": print "HMC command Failed: @cmdLine  \n Err - $errVal $retVal";
       $retVal = $!;
    } else {

    }
    return ( $errVal, $retVal);
}

sub threadFunc (){
   my $Cnt = shift;
   if($Cnt == 1) {
      my $Loop = 0;
      while ($Loop++ < $runInterval) {
         ($errOutVm,@vmStt) = runCommand ("vmstat -h 2 $shared::execCount   2>&1") ;
         consumeVmstat();
      } 
   }
   elsif($Cnt == 2 ) {
      my $Loop = 0;
      while ($Loop++ < $runInterval) {
         ($errOuthpmSt,@hpmStt) = runCommand ("hpmstat -m dL1_Reloads_percentage_per_ref  1 $shared::execCount 2>&1");
            consumeHpmstat();
       }
    }
    elsif($Cnt == 3) {
       my $Loop = 0;
       while ($Loop++ < $runInterval) {
          `rm -rf /tmp/iostat.out`;
          `iostat -D 2 $shared::execCount 2>&1 > /tmp/iostat.out`;
          #($errOutIO,@IOStt) = runCommand ("iostat -D 2 $shared::execCount 2>&1");
          consumeIostat();
       }
    }
    elsif($Cnt == 4) {
      my $Loop;
      my $Cnt = int(($shared::execCount * 2  * $runInterval) / 60);
      if ( $Cnt > 30 ){
         $TopasrecLpCnt = $Cnt/30;
      }
      $TopasrecLpCnt++;
      $Loop = 0;
       while ($Loop++ < $TopasrecLpCnt) {
          `rm -rf /tmp/topasout_*.topas`;
          my $runCnt = 30;  #Run it for 30mins on every iteration
          if ( ($Loop * 30) > $Cnt ){
            $runCnt = $Cnt - ($Loop * 30);   
           }
          ($errOutLparSt,@LparStt) = runCommand ("topasrec -C  -o /tmp/topasout_$shared::randNo -c $runCnt -s 60 2>&1");
          consumeTopasrec();
       }
    }
    elsif($Cnt == 5) {
      my $Loop = 0;
      if($smt_flag != -1){
         while ($Loop++ < $runInterval) {
            ($errOutMpst,@Mpstt) = runCommand ("mpstat -s 2 $shared::execCount 2>&1");
            consumeMpsstat();
         }
      }
    }
    elsif($Cnt == 6) {
       my $Loop = 0;
       while ($Loop++ < $runInterval) {
          ($errOutSvm,@SvMonStt) = runCommand ("svmon -G  -i 1 $shared::execCount   2>&1") ;
          consumeSvmon();
       }
    }
    elsif($Cnt == 7) {
       my $timInmin = $shared::execTime/60;
       `./fcSt $timInmin "/tmp/$shared::randNo.txt"`; 
    }
}

sub runCommand () {
    $timeStrt = localtime();
    my @retVal = `@_`;
    $timeEnd = localtime();
    my $errVal = $?;
    if ( $errVal != 0 ){
       @retVal = $!;
    } else {
       
    }
#    print "retVal = @retVal";
    return ( $errVal, @retVal);
}
sub datastore {
    
}
return 1;
