#!/usr/bin/perl -w

##########################################################
## #
## #
## #
## #
##########################################################


use strict;
use warnings;
use shared;
use Getopt::Long;
use collector;
use Class::Struct;

my ($helpMsg,$version);
my $dfltRuntime = 30;
$shared::execTime = 30;

$shared::hmcUsr = "hscpe";
if ( ! GetOptions ( 
       "verbose" => \$shared::verbose,
       "version|v"=> \$version, 
       "autoname|a"=> \$shared::FileName,
       "hmc=s" => \$shared::hmc, 
       "t=i" => \$shared::execTime,
       "sdmc=s" => \$shared::sdmc, 
       "user=s" => \$shared::hmcUsr,  
       "sys=s" => \$shared::cec, 
       "level" => \$shared::sysLevel, 
       "help|h" => \$helpMsg) ){
       print "\n Usage: ./virt_pa.pl -t <time> -hmc < console hostname> -user  <hmc user>  -sys <cecname> -level (sys|lpar)";
       print "\n Where \n -t is time in min (minimum of 30min is considered) \n -hmc  is the HMC to which this server is connected to. SDMC or HMC is must.\n -user is the HMC's user\n -sys CEC name on which this lpar is configured \n -level is option and can be specified as sys or lpar. By default lpar level is considered.";
       exit;
}

if (defined $version ){
   print "\nPowerVM Virtualization Advisor version - 07022012 \n";
   exit;
}
if ((!defined $shared::hmc && !defined $shared::sdmc)|| !defined $shared::cec || defined $helpMsg){
   print "\n Usage:./virt_pa.pl -t <time> -hmc < console hostname> -user  <hmc user>  -sys <cecname> -level (sys|lpar)";
   print "\n Where \n -t is time in min (minimum of 30min is considered) \n -hmc  is the HMC to which this server is connected to. SDMC or HMC is must.\n -user is the HMC's user\n -sys CEC name on which this lpar is configured \n -level is option and can be specified as sys or lpar. By default lpar level is considered.";
   exit;
}
print "\nVirtualization Performance Advisor.....\n";

if (defined $shared::sysLevel &&  $shared::sysLevel =~ /sys/) {
}
$shared::randNo = int(rand(20000));

open ( $shared::RPRTFILE, ">/tmp/$shared::randNo.txt") or die "Cannot open temp file in /tmp. $!";

if ($shared::execTime < $dfltRuntime) {
    $shared::execTime = $dfltRuntime;
}
 $shared::execTime = $shared::execTime * 60;
 use integer;
 $shared::execCount = $shared::execTime/2; # Considering 2s between samples.

collector::executeCollector();
#`./fcSt $shared::execTime "/tmp/$shared::randNo.txt"`;
close( $shared::RPRTFILE);
`./vpa /tmp/$shared::randNo.txt`;
